/* Copyright (c) 2015, Electric Cloud, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *   - Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *
 *   - Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/* (As an historical note, the above license instantiates
 * the "BSD 2-Clause License" template that was presented
 * by the Open Source Initiative at
 *
 *   http://www.opensource.org/licenses/bsd-license.php
 *
 * on 2012-02-23.)
 */

/* Summary:
 *
 * Declares utilties for timing tests and reporting those figures.
 */

#ifndef VRPSX_DIRECT_TESTS_TEST_TIMER_H
#define VRPSX_DIRECT_TESTS_TEST_TIMER_H 1

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "test_dlist.h"
#include <time.h>


typedef struct test_timer_struct {
    dlink_t timings;
} test_timer_t;

extern void test_timer_construct(
    test_timer_t *obj);

extern void test_timer_destroy(
    test_timer_t *obj);

extern void test_timer_add(
    test_timer_t *obj,
    char const *name,
    struct timespec const *elapsed);

extern void test_timer_add_difference(
    test_timer_t *obj,
    char const *name,
    struct timespec const *begin,
    struct timespec const *end);

extern void test_timer_report(
    test_timer_t *obj);


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* VRPSX_DIRECT_TESTS_TEST_TIMER_H */
